---
name: Bug report
about: Issue tracker for bug reports

---

## 🐞 Bug Report

A clear and concise description of what the bug is.

## What is the severity of this bug?

**Critical - Urgent:** We can't do anything if this isn't actioned immediately (product doesn't function without this, it's blocking us or users, or it resolves a high severity security issue). Whole team should drop what they're doing and work on this. 

**Critical:** We can't do anything if this isn't actioned immediately (product doesn't function without this, it's blocking us or users, or it resolves a high severity security issue). One person should look at this right now. 

**Important:** * We have to do this before we ship, but it can wait until the next sprint (product or feature won't function without it, but it's not blocking us or users right now). Team should do this in the next sprint.

**Should have:** * It would be better if we do this before we ship, but it's OK if we don't (product functions without this, but it's a better user experience). Consider adding to a future sprint.

**Could have:** It really doesn't matter if we do this (product functions without this, impact to user is minimal). 

## Reproduction steps

Steps to reproduce the behaviour:

1. Make API call '...'
1. See error

- [ ] I followed these steps and was able to reproduce the issue

## Expected behaviour

A clear and concise description of what you expected to happen.

## Screenshots

If applicable, add screenshots to help explain your problem.

## Specifications

- System: (e.g. macOS 10.13.4, Linux)
- Go: (e.g. 1.13)

## Additional context

Add any other context about the problem here.
